<?php
class model_component_generator extends model
{
    public function table_exists($name)
    {
        $r = $this->dbh->row("SELECT name FROM sqlite_master WHERE type='table' AND name='$name'");
        return !empty($r);

        
    }


    public function generate_component($params)
    {
        extract($params);

        if (!$this->dbh->exec(
            "CREATE TABLE $sysname (
                id INTEGER PRIMARY KEY AUTOINCREMENT,
                url TEXT,
                header TEXT,
                overview TEXT,
                photo TEXT,
                text TEXT,
                title TEXT,
                keywords TEXT,
                description TEXT,
                date_create INTEGER,
                date_edit INTEGER,
                date_publish INTEGER,
                parent_id INTEGER,
                is_category INTEGER
            )" 
        )) return false;

        if (!mkdir(ROOT_DIR.'/modules/components/'.$sysname.'/front_end/views', 0755, true)) return false;
        if (!mkdir(ROOT_DIR.'/modules/components/'.$sysname.'/back_end/views', 0755, true)) return false;

        $src = ROOT_DIR.'/modules/components/generator/back_end/source';
        $dst = ROOT_DIR.'/modules/components/'.$sysname;

        copy($src.'/no-photo.jpg', $dst.'/no-photo.jpg');

        copy($src.'/back_end/views/404_not_found.tpl', $dst.'/back_end/views/404_not_found.tpl');
        copy($src.'/back_end/views/editor.tpl', $dst.'/back_end/views/editor.tpl');
        copy($src.'/back_end/views/table.tpl', $dst.'/back_end/views/table.tpl');
        copy($src.'/back_end/component.ini', $dst.'/back_end/component.ini');
        copy($src.'/back_end/controller.php', $dst.'/back_end/controller_component_'.$sysname.'.php');
        copy($src.'/back_end/model.php', $dst.'/back_end/model_component_'.$sysname.'.php');

        copy($src.'/front_end/views/404_not_found.tpl', $dst.'/front_end/views/404_not_found.tpl');
        copy($src.'/front_end/views/article.tpl', $dst.'/front_end/views/article.tpl');
        copy($src.'/front_end/views/category.tpl', $dst.'/front_end/views/category.tpl');
        copy($src.'/front_end/views/style.css', $dst.'/front_end/views/style.css');
        copy($src.'/front_end/controller.php', $dst.'/front_end/controller_component_'.$sysname.'.php');
        copy($src.'/front_end/model.php', $dst.'/front_end/model_component_'.$sysname.'.php');

        $files_list = Array(
            $dst.'/back_end/views/table.tpl',
            $dst.'/back_end/component.ini',
            $dst.'/back_end/controller_component_'.$sysname.'.php',
            $dst.'/back_end/model_component_'.$sysname.'.php',
            $dst.'/front_end/controller_component_'.$sysname.'.php',
            $dst.'/front_end/model_component_'.$sysname.'.php'
        );

        $search = Array(
            '{{sysname}}',
            '{{name}}',
            '{{element_name}}',
            '{{element_add_name}}'
        );

        $replacements = Array(
            $sysname,
            $name,
            $element_name,
            $element_add_name
        );

        foreach ($files_list as $f) {
            file_put_contents($f, str_replace($search, $replacements, file_get_contents($f)));
        }

        return true;
    }
}